//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace MonitoringClient.GatewayMonitoringService
{
    
    
    /// <summary>
    /// Class that implements the IGatewayMonitoringService interface through SiLA2
    /// </summary>
    public partial class GatewayMonitoringServiceClient : IGatewayMonitoringService
    {
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.gateway.gatewaymonitoringservice.v1.GatewayMonitoringServi" +
            "ce";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public GatewayMonitoringServiceClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
        }
        
        /// <summary>
        /// Listens to messages of servers that follow the specified pattern
        /// </summary>
        /// <param name="serverPattern">The pattern of the server UUID that is followed, can contain wildcards like *</param>
        public virtual Tecan.Sila2.IIntermediateObservableCommand<GatewayMonitoringMessage> ListenToServerMessages(string serverPattern)
        {
            ListenToServerMessagesRequestDto request = new ListenToServerMessagesRequestDto(serverPattern, null);
            request.Validate();
            return _channel.ExecuteIntermediatesCommand<ListenToServerMessagesRequestDto, GatewayMonitoringMessage, ListenToServerMessagesIntermediateDto>(_serviceName, "ListenToServerMessages", request, ConvertListenToServerMessagesIntermediate, ConvertListenToServerMessagesException, _executionManager.CreateCallOptions(request.CommandIdentifier));
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of ListenToServerMessages to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertListenToServerMessagesException(string errorIdentifier, string errorMessage)
        {
            return null;
        }
        
        /// <summary>
        /// Unwraps the response of the ListenToServerMessagesIntermediate command
        /// </summary>
        /// <param name="value">The response data transfer object</param>
        /// <returns>The actual response</returns>
        private GatewayMonitoringMessage ConvertListenToServerMessagesIntermediate(ListenToServerMessagesIntermediateDto value)
        {
            return value.Intermediate.Extract(_executionManager.DownloadBinaryStore);
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Gateway Monitoring Service.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class GatewayMonitoringServiceClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/gateway/GatewayMonitoringService/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IGatewayMonitoringService);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new GatewayMonitoringServiceClient(channel, executionManager);
        }
    }
}

